import * as PIXI from "../../pixi/pixi.mjs"

/**
 * Base class for all game objects.
 * Contains only necessary functions
 */
export class GameObject {
    
    id = -1;
    tickEnabled = true;
    // markedAsWaitingForDestruction = false;
    // markedAsInitialized = false;

    /**
     * GameObject id
     * @param {Number} id 
     * @param {Boolean} tickAble 
     */
    constructor(id, tickAble)
    {
        this.id = id;
        this.tickEnabled = tickAble;
    };

    /**
     * called before object's destruction
     */
    preDestroy(){};

    /**
     * called after spawn
     */
    afterSpawn(){};

    /**
     * called before spawn
     */
    preSpawn(){};

    /**
     * called every frame
     * @param {PIXI.Ticker} ticker 
     */
    tick(ticker){};
};